commit 70874918ca50439f9190840ecaef683762131dfa
Author: freddy77 <freddy77>
Date:   Thu May 28 16:23:31 2009 +0000

    improve support for mssql2005 types

diff --git a/ChangeLog b/ChangeLog
index 59e991c..c7de97f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,13 @@
+Thu May 28 18:23:16 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h misc/types.txt src/apps/tsql.c src/ctlib/ct.c:
+	* src/dblib/bcp.c src/dblib/buffering.h src/dblib/dblib.c:
+	* src/dblib/rpc.c src/odbc/odbc.c src/odbc/odbc_util.c:
+	* src/odbc/prepare_query.c src/odbc/sql2tds.c src/tds/mem.c:
+	* src/tds/query.c src/tds/read.c src/tds/tds_checks.c:
+	* src/tds/token.c src/tds/unittests/dataread.c:
+	* src/tds/unittests/utf8_1.c src/tds/unittests/utf8_2.c:
+	- improve support for mssql2005 types (still under development)
+
 Thu May 28 18:17:43 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/data.c: add tests for mssql2005 types
 
@@ -1588,4 +1598,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2800 2009/05/28 16:17:49 freddy77 Exp $
+$Id: ChangeLog,v 1.2801 2009/05/28 16:23:31 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 9b31c4f..04dc446 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.313 2009/04/18 19:35:38 jklowden Exp $ */
+/* $Id: tds.h,v 1.314 2009/05/28 16:23:31 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -754,6 +754,7 @@ typedef enum tds_encryption_level {
 	(x)==XSYBNCHAR)
 
 #define is_blob_type(x) (x==SYBTEXT || x==SYBIMAGE || x==SYBNTEXT)
+#define is_blob_col(x) ((x)->column_varint_size > 2)
 /* large type means it has a two byte size field */
 /* define is_large_type(x) (x>128) */
 #define is_numeric_type(x) (x==SYBNUMERIC || x==SYBDECIMAL)
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index 0e86a68..7777542 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.127 2009/04/18 19:35:38 jklowden Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.128 2009/05/28 16:23:31 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -235,7 +235,7 @@ do_query(TDSSOCKET * tds, char *buf, int opt_flags)
 					ctype = tds_get_conversion_type(col->column_type, col->column_size);
 
 					src = col->column_data;
-					if (is_blob_type(col->column_type))
+					if (is_blob_col(col))
 						src = (unsigned char *) ((TDSBLOB *) src)->textvalue;
 					srclen = col->column_cur_size;
 
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index 86629cd..def81f3 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.188 2009/05/11 07:25:25 freddy77 Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.189 2009/05/28 16:23:31 freddy77 Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -1770,7 +1770,7 @@ _ct_bind_data(CS_CONTEXT *ctx, TDSRESULTINFO * resinfo, TDSRESULTINFO *bindinfo,
 				srctype = _ct_get_client_type(curcol->column_type, curcol->column_usertype, curcol->column_size);
 
 				src = curcol->column_data;
-				if (is_blob_type(curcol->column_type))
+				if (is_blob_col(curcol))
 					src = (unsigned char *) ((TDSBLOB *) src)->textvalue;
 
 				srclen = curcol->column_cur_size;
@@ -2691,7 +2691,7 @@ ct_get_data(CS_COMMAND * cmd, CS_INT item, CS_VOID * buffer, CS_INT buflen, CS_I
 		curcol = resinfo->columns[item - 1];
 
 		src = curcol->column_data;
-		if (is_blob_type(curcol->column_type)) {
+		if (is_blob_col(curcol)) {
 			blob = (TDSBLOB *) src;
 			src = (unsigned char *) blob->textvalue;
 		}
@@ -2731,7 +2731,7 @@ ct_get_data(CS_COMMAND * cmd, CS_INT item, CS_VOID * buffer, CS_INT buflen, CS_I
 		/* get at the source data */
 		curcol = resinfo->columns[item - 1];
 		src = curcol->column_data;
-		if (is_blob_type(curcol->column_type))
+		if (is_blob_col(curcol))
 			src = (unsigned char *) ((TDSBLOB *) src)->textvalue;
 
 	}
@@ -3887,7 +3887,7 @@ paramrowalloc(TDSPARAMINFO * params, TDSCOLUMN * curcol, int param_num, void *va
 			size = curcol->column_size;
 		}
 		/* TODO blobs */
-		if (!is_blob_type(curcol->column_type))
+		if (!is_blob_col(curcol))
 			memcpy(curcol->column_data, value, size);
 		else {
 			TDSBLOB *blob = (TDSBLOB *) curcol->column_data;
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index c629325..34fa10e 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -61,7 +61,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.185 2009/05/20 16:36:58 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.186 2009/05/28 16:23:32 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -948,7 +948,7 @@ _bcp_exec_out(DBPROCESS * dbproc, DBINT * rows_copied)
 
 				src = curcol->column_data;
 
-				if (is_blob_type(curcol->column_type)) {
+				if (is_blob_col(curcol)) {
 					src = (BYTE *) ((TDSBLOB *) src)->textvalue;
 				}
 
diff --git a/src/dblib/buffering.h b/src/dblib/buffering.h
index d07c32b..f51d92c 100644
--- a/src/dblib/buffering.h
+++ b/src/dblib/buffering.h
@@ -332,9 +332,8 @@ buffer_transfer_bound_data(DBPROC_ROWBUF *buf, TDS_INT res_type, TDS_INT compute
 		else
 			src = curcol->column_data;
 		srclen = curcol->column_cur_size;
-		if (is_blob_type(curcol->column_type)) {
+		if (is_blob_col(curcol))
 			src = (BYTE *) ((TDSBLOB *) src)->textvalue;
-		}
 		desttype = _db_get_server_type(curcol->column_bindtype);
 		srctype = tds_get_conversion_type(curcol->column_type, curcol->column_size);
 
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index c268aa6..c9bd4ee 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.349 2009/04/23 13:12:43 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.350 2009/05/28 16:23:32 freddy77 Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -3094,7 +3094,7 @@ dbdata(DBPROCESS * dbproc, int column)
 	if (colinfo->column_cur_size < 0)
 		return NULL;
 
-	if (is_blob_type(colinfo->column_type)) {
+	if (is_blob_col(colinfo)) {
 		BYTE *res = (BYTE *) ((TDSBLOB *) colinfo->column_data)->textvalue;
 		if (!res)
 			return (BYTE *) empty;
@@ -4181,7 +4181,7 @@ dbadata(DBPROCESS * dbproc, int computeid, int column)
 	if (!colinfo)
 		return NULL;
 
-	if (is_blob_type(colinfo->column_type)) {
+	if (is_blob_col(colinfo)) {
 		return (BYTE *) ((TDSBLOB *) colinfo->column_data)->textvalue;
 	}
 
@@ -6241,7 +6241,7 @@ dbtxtimestamp(DBPROCESS * dbproc, int column)
 	tdsdump_log(TDS_DBG_FUNC, "dbtxtimestamp(%p, %d)\n", dbproc, column);
 
 	colinfo = dbcolptr(dbproc, column);
-	if (!colinfo || !is_blob_type(colinfo->column_type))
+	if (!colinfo || !is_blob_col(colinfo))
 		return NULL;
 
 	blob = (TDSBLOB *) colinfo->column_data;
@@ -6267,7 +6267,7 @@ dbtxptr(DBPROCESS * dbproc, int column)
 	tdsdump_log(TDS_DBG_FUNC, "dbtxptr(%p, %d)\n", dbproc, column);
 
 	colinfo = dbcolptr(dbproc, column);
-	if (!colinfo || !is_blob_type(colinfo->column_type))
+	if (!colinfo || !is_blob_col(colinfo))
 		return NULL;
 
 	blob = (TDSBLOB *) colinfo->column_data;
diff --git a/src/dblib/rpc.c b/src/dblib/rpc.c
index 8d8947d..a335112 100644
--- a/src/dblib/rpc.c
+++ b/src/dblib/rpc.c
@@ -54,7 +54,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: rpc.c,v 1.68 2009/03/24 01:22:14 jklowden Exp $");
+TDS_RCSID(var, "$Id: rpc.c,v 1.69 2009/05/28 16:23:32 freddy77 Exp $");
 
 static void rpc_clear(DBREMOTE_PROC * rpc);
 static void param_clear(DBREMOTE_PROC_PARAM * pparam);
@@ -334,7 +334,7 @@ param_row_alloc(TDSPARAMINFO * params, TDSCOLUMN * curcol, int param_num, void *
 		return NULL;
 	if (size > 0 && value) {
 		tdsdump_log(TDS_DBG_FUNC, "copying %d bytes of data to parameter #%d\n", size, param_num);
-		if (!is_blob_type(curcol->column_type)) {
+		if (!is_blob_col(curcol)) {
 			memcpy(curcol->column_data, value, size);
 		} else {
 			TDSBLOB *blob = (TDSBLOB *) curcol->column_data;
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 2ab668a..78d7401 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.510 2009/04/18 19:35:38 jklowden Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.511 2009/05/28 16:23:32 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3655,7 +3655,7 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 				TDS_CHAR *data_ptr = (TDS_CHAR *) drec_ard->sql_desc_data_ptr;
 
 				src = (TDS_CHAR *) colinfo->column_data;
-				if (is_blob_type(colinfo->column_type))
+				if (is_blob_col(colinfo))
 					src = ((TDSBLOB *) src)->textvalue;
 				srclen = colinfo->column_cur_size;
 				c_type = drec_ard->sql_desc_concise_type;
@@ -4708,7 +4708,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 
 			/* 2003-8-29 check for an old bug -- freddy77 */
 			assert(colinfo->column_text_sqlgetdatapos >= 0);
-			if (is_blob_type(colinfo->column_type))
+			if (is_blob_col(colinfo))
 				src = ((TDSBLOB *) src)->textvalue;
 			src += colinfo->column_text_sqlgetdatapos;
 			srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 450f391..641b5e8 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.106 2008/10/22 15:22:59 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.107 2009/05/28 16:23:32 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -209,7 +209,7 @@ odbc_set_return_params(struct _hstmt *stmt, unsigned int n_row)
 		}
 
 		src = (TDS_CHAR *) colinfo->column_data;
-		if (is_blob_type(colinfo->column_type))
+		if (is_blob_col(colinfo))
 			src = ((TDSBLOB *) src)->textvalue;
 		srclen = colinfo->column_cur_size;
 		c_type = drec_apd->sql_desc_concise_type;
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index 418513c..a3be5f4 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.77 2009/05/21 16:41:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.78 2009/05/28 16:23:32 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -311,7 +311,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 
 	curcol = stmt->params->columns[stmt->param_num - (stmt->prepared_query_is_func ? 2 : 1)];
 	blob = NULL;
-	if (is_blob_type(curcol->column_type))
+	if (is_blob_col(curcol))
 		blob = (TDSBLOB *) curcol->column_data;
 	assert(curcol->column_cur_size <= curcol->column_size);
 	need_bytes = curcol->column_size - curcol->column_cur_size;
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 27e657c..7d57bc4 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.82 2009/05/22 17:33:36 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.83 2009/05/28 16:23:32 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -206,7 +206,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		TDSSOCKET *tds = dbc->tds_socket;
 		TDSICONV *conv = tds->char_convs[is_unicode_type(dest_type) ? client2ucs2 : client2server_chardata];
 
-		tds_set_column_type(tds, curcol, dest_type);
+		tds_set_param_type(tds, curcol, dest_type);
 
                 curcol->char_conv = tds_iconv_get(tds, ODBC_WIDE_NAME, conv->server_charset.name);
 		memcpy(curcol->column_collation, tds->collation, sizeof(tds->collation));
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 33d6e99..3eb1231 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.188 2009/02/07 00:26:22 jklowden Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.189 2009/05/28 16:23:32 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -291,7 +291,7 @@ _tds_param_free(TDSCOLUMN *col)
 	if (!col->column_data)
 		return;
 
-	if (is_blob_type(col->column_type)) {
+	if (is_blob_col(col)) {
 		TDSBLOB *blob = (TDSBLOB *) col->column_data;
 		free(blob->textvalue);
 	}
@@ -313,7 +313,7 @@ tds_alloc_param_data(TDSCOLUMN * curparam)
 
 	if (is_numeric_type(curparam->column_type)) {
 		data_size = sizeof(TDS_NUMERIC);
-	} else if (is_blob_type(curparam->column_type)) {
+	} else if (is_blob_col(curparam)) {
 		data_size = sizeof(TDSBLOB);
 	} else {
 		data_size = curparam->column_size;
@@ -330,7 +330,7 @@ tds_alloc_param_data(TDSCOLUMN * curparam)
 	if (!data)
 		return NULL;
 	/* if is a blob reset buffer */
-	if (is_blob_type(curparam->column_type))
+	if (is_blob_col(curparam))
 		memset(data, 0, sizeof(TDSBLOB));
 
 	return data;
@@ -438,7 +438,7 @@ _tds_row_free(TDSRESULTINFO *res_info, unsigned char *row)
 	for (i = 0; i < res_info->num_cols; ++i) {
 		col = res_info->columns[i];
 		
-		if (is_blob_type(col->column_type)) {
+		if (is_blob_col(col)) {
 			TDSBLOB *blob = (TDSBLOB *) &row[col->column_data - res_info->current_row];
 			if (blob->textvalue)
 				TDS_ZERO_FREE(blob->textvalue);
@@ -469,7 +469,7 @@ tds_alloc_row(TDSRESULTINFO * res_info)
 
 		if (is_numeric_type(col->column_type)) {
 			row_size += sizeof(TDS_NUMERIC);
-		} else if (is_blob_type(col->column_type)) {
+		} else if (is_blob_col(col)) {
 			row_size += sizeof(TDSBLOB);
 		} else {
 			row_size += col->column_size;
@@ -494,7 +494,7 @@ tds_alloc_row(TDSRESULTINFO * res_info)
 
 		if (is_numeric_type(col->column_type)) {
 			row_size += sizeof(TDS_NUMERIC);
-		} else if (is_blob_type(col->column_type)) {
+		} else if (is_blob_col(col)) {
 			row_size += sizeof(TDSBLOB);
 		} else {
 			row_size += col->column_size;
diff --git a/src/tds/query.c b/src/tds/query.c
index c45be3b..3e07f95 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.236 2009/05/26 16:20:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.237 2009/05/28 16:23:32 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -1473,7 +1473,7 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	size = tds_fix_column_size(tds, curcol);
 
 	src = curcol->column_data;
-	if (is_blob_type(curcol->column_type)) {
+	if (is_blob_col(curcol)) {
 		blob = (TDSBLOB *) src;
 		src = (unsigned char *) blob->textvalue;
 	}
@@ -2896,7 +2896,7 @@ tds_put_param_as_string(TDSSOCKET * tds, TDSPARAMINFO * params, int n)
 		return TDS_SUCCEED;
 	}
 	
-	if (is_blob_type(curcol->column_type))
+	if (is_blob_col(curcol))
 		src = ((TDSBLOB *)src)->textvalue;
 
 	save_src = src;
diff --git a/src/tds/read.c b/src/tds/read.c
index 1f7886f..d655cf4 100644
--- a/src/tds/read.c
+++ b/src/tds/read.c
@@ -47,7 +47,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: read.c,v 1.109 2009/05/11 09:05:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: read.c,v 1.110 2009/05/28 16:23:32 freddy77 Exp $");
 
 static int read_and_convert(TDSSOCKET * tds, const TDSICONV * char_conv,
 			    size_t * wire_size, char **outbuf, size_t * outbytesleft);
@@ -232,7 +232,7 @@ tds_get_char_data(TDSSOCKET * tds, char *row_buffer, size_t wire_size, TDSCOLUMN
 	TDSBLOB *blob = NULL;
 	char *dest = row_buffer;
 
-	if (is_blob_type(curcol->column_type)) {
+	if (is_blob_col(curcol)) {
 		blob = (TDSBLOB *) row_buffer;
 		dest = blob->textvalue;
 	}
diff --git a/src/tds/tds_checks.c b/src/tds/tds_checks.c
index 2ba07fa..81cba27 100644
--- a/src/tds/tds_checks.c
+++ b/src/tds/tds_checks.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: tds_checks.c,v 1.21 2008/10/28 12:50:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tds_checks.c,v 1.22 2009/05/28 16:23:32 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -177,7 +177,8 @@ tds_check_column_extra(const TDSCOLUMN * column)
 
 	assert(column);
 
-	assert(column->column_varint_size <= 5 && column->column_varint_size != 3);
+	/* 8 is for varchar(max) or similar */
+	assert(column->column_varint_size == 8 || (column->column_varint_size <= 5 && column->column_varint_size != 3));
 
 	assert(column->column_scale <= column->column_prec);
 	assert(column->column_prec <= 77);
@@ -193,9 +194,19 @@ tds_check_column_extra(const TDSCOLUMN * column)
 	assert(tds_get_cardinal_type(column->on_server.column_type) == column->column_type
 		|| (tds_get_null_type(column->column_type) == column->on_server.column_type 
 		&& column->column_varint_size == 1 && is_fixed_type(column->column_type)));
+
+	varint_ok = 0;
+	if (is_blob_type(column->column_type)) {
+		assert(column->column_varint_size >= 4);
+	} else if (column->column_varint_size == 8) {
+		assert(column->on_server.column_type == XSYBVARCHAR || column->on_server.column_type == XSYBVARBINARY || column->on_server.column_type == XSYBNVARCHAR);
+		varint_ok = 1;
+	} else {
+		assert(column->column_varint_size < 3);
+	}
 	tds.minor_version = 0;
 	tds.major_version = 5;
-	varint_ok = tds_get_varint_size(&tds, column->on_server.column_type) == column->column_varint_size;
+	varint_ok = varint_ok || tds_get_varint_size(&tds, column->on_server.column_type) == column->column_varint_size;
 	tds.major_version = 7;
 	varint_ok = varint_ok || tds_get_varint_size(&tds, column->on_server.column_type) == column->column_varint_size;
 	assert(varint_ok);
diff --git a/src/tds/token.c b/src/tds/token.c
index 0641bc9..39b5465 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.359 2009/01/16 20:27:58 jklowden Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.360 2009/05/28 16:23:32 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -1441,8 +1441,10 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		curcol->column_size = tds_get_smallint(tds);
 #ifdef ENABLE_DEVELOPING
 		/* under TDS9 this means ?var???(MAX) */
-		if (curcol->column_size < 0 && IS_TDS90(tds))
+		if (curcol->column_size < 0 && IS_TDS90(tds)) {
 			curcol->column_size = 0x1ffffffflu;
+			curcol->column_varint_size = 8;
+		}
 #endif
 		break;
 	case 1:
@@ -1951,6 +1953,8 @@ tds9_get_varmax(TDSSOCKET * tds, TDSCOLUMN * curcol)
 {
 	TDS_INT8 len = tds_get_int8(tds);
 	TDS_INT chunk_len;
+	TDS_CHAR **p;
+	size_t offset;
 
 	/* NULL */
 	if (len == -1) {
@@ -1958,11 +1962,28 @@ tds9_get_varmax(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		return TDS_SUCCEED;
 	}
 
+	curcol->column_cur_size = 0;
+	offset = 0;
+	p = &(((TDSBLOB*) curcol->column_data)->textvalue);
 	for (;;) {
+		TDS_CHAR *tmp;
+
 		chunk_len = tds_get_int(tds);
-		if (chunk_len < 0)
+		if (chunk_len <= 0) {
+			curcol->column_cur_size = offset;
 			return TDS_SUCCEED;
+		}
+		if (*p)
+			tmp = (TDS_CHAR*) malloc(chunk_len);
+		else
+			tmp = (TDS_CHAR*) realloc(*p, offset + chunk_len);
+		if (!tmp)
+			return TDS_FAIL;
+		*p = tmp;
+		tds_get_n(tds, *p + offset, chunk_len);
+		offset += chunk_len;
 	}
+	return TDS_SUCCEED;
 }
 #endif
 
@@ -2024,11 +2045,11 @@ tds_get_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	case 5:
 		colsize = tds_get_int(tds);
 		break;
-	case 2:
 #ifdef ENABLE_DEVELOPING
-		if (curcol->column_size == 0x1ffffffflu)
-			return tds9_get_varmax(tds, curcol);
+	case 8:
+		return tds9_get_varmax(tds, curcol);
 #endif
+	case 2:
 		colsize = tds_get_smallint(tds);
 		break;
 	case 1:
@@ -2090,7 +2111,7 @@ tds_get_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 			tds_swap_numeric(num);
 		}
 		curcol->column_cur_size = colsize;
-	} else if (is_blob_type(curcol->column_type)) {
+	} else if (is_blob_col(curcol)) {
 		TDS_CHAR *p;
 		int new_blob_size;
 		assert(blob == (TDSBLOB *) dest); 	/* cf. column_varint_size case 4, above */
diff --git a/src/tds/unittests/dataread.c b/src/tds/unittests/dataread.c
index 887d554..d0a1843 100644
--- a/src/tds/unittests/dataread.c
+++ b/src/tds/unittests/dataread.c
@@ -22,7 +22,7 @@
 #include <assert.h>
 #include <tdsconvert.h>
 
-static char software_version[] = "$Id: dataread.c,v 1.19 2007/10/16 15:12:23 freddy77 Exp $";
+static char software_version[] = "$Id: dataread.c,v 1.20 2009/05/28 16:23:32 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int g_result = 0;
@@ -119,7 +119,7 @@ test0(const char *type, ...)
 
 		assert(i_row < num_data);
 
-		if (is_blob_type(curcol->column_type)) {
+		if (is_blob_col(curcol)) {
 			TDSBLOB *blob = (TDSBLOB *) src;
 
 			src = blob->textvalue;
diff --git a/src/tds/unittests/utf8_1.c b/src/tds/unittests/utf8_1.c
index 9e7971e..d8c2340 100644
--- a/src/tds/unittests/utf8_1.c
+++ b/src/tds/unittests/utf8_1.c
@@ -21,7 +21,7 @@
 #include <ctype.h>
 #include <assert.h>
 
-static char software_version[] = "$Id: utf8_1.c,v 1.12 2006/01/24 15:03:28 freddy77 Exp $";
+static char software_version[] = "$Id: utf8_1.c,v 1.13 2009/05/28 16:23:32 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static TDSSOCKET *tds;
@@ -165,7 +165,7 @@ test(const char *type, const char *test_name)
 			TDSCOLUMN *curcol = tds->current_results->columns[0];
 			char *src = (char *) curcol->column_data;
 
-			if (is_blob_type(curcol->column_type)) {
+			if (is_blob_col(curcol)) {
 				TDSBLOB *blob = (TDSBLOB *) src;
 
 				src = blob->textvalue;
diff --git a/src/tds/unittests/utf8_2.c b/src/tds/unittests/utf8_2.c
index 0f896a1..fa1fa22 100644
--- a/src/tds/unittests/utf8_2.c
+++ b/src/tds/unittests/utf8_2.c
@@ -22,7 +22,7 @@
 #include <assert.h>
 
 /* try conversion from utf8 to iso8859-1 */
-static char software_version[] = "$Id: utf8_2.c,v 1.14 2007/01/18 07:58:08 freddy77 Exp $";
+static char software_version[] = "$Id: utf8_2.c,v 1.15 2009/05/28 16:23:32 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static TDSSOCKET *tds;
@@ -107,7 +107,7 @@ test(int n, int type)
 	curcol = tds->current_results->columns[0];
 	src = (char*) curcol->column_data;
 
-	if (is_blob_type(curcol->column_type)) {
+	if (is_blob_col(curcol)) {
 		TDSBLOB *blob = (TDSBLOB *) src;
 
 		src = blob->textvalue;

